# http://www.igvita.com/2008/08/10/asynchronous-db-dbslayer-httpasynchronous-db-dbslayer-http

require 'rubygems'
require 'eventmachine'
require 'evma_httpserver'
require 'json'
require 'cgi'

class Handler  < EventMachine::Connection
  include EventMachine::HttpServer
 
  def process_http_request
    resp = EventMachine::DelegatedHttpResponse.new( self )
    query = {"SQL" => "USE dbslayer;SELECT * from widgets where id IN (#{(0..500).map { rand(99999) }.join(',')})"}
   
    http = EM::Protocols::HttpClient2.connect("localhost", 81)
    d = http.get "/db?" + CGI.escape(query.to_json)
 
    # defer the response until we get response from DBSlayer
    d.callback {
     	resp.status = 200
      resp.content = d.content
      resp.send_response
    }
  end
end
 
EventMachine::run {
  EventMachine.epoll
  EventMachine::start_server("0.0.0.0", 8082, Handler)
  puts "Listening..."
}